import whisper
import opencc
import time
def transformerVideoToAudio(audio_path=r"GetAudio\audio_reserve\audio.wav",
                            text_path=r"GetAudio\audio_reserve\text.txt",
                            time_path=r"GetAudio\audio_reserve\time.txt"):
    converter=opencc.OpenCC("t2s.json")
    # 转录音频
    model = whisper.load_model("base")
    result = model.transcribe(audio_path, word_timestamps=True, language="Chinese")

    # 获取"segments"键对应的值
    with open (text_path,"w",encoding="utf-8") as f:
        result_text=result['text']
        result_text=converter.convert(result_text)
        f.write(result_text)
        print("successfully saved segments.txt!")
    #打开一个.txt文件以写入"segments"的内容
    segments = result.get("segments")

    if segments is not None:
        with open(time_path, "w", encoding="utf-8") as txt_file:
            for segment in segments:
                start_time = segment.get("start")
                end_time = segment.get("end")
                text = segment.get("text")
                text=converter.convert(text)
                txt_file.write(f"start:{start_time} --> end:{end_time} {text}\n")

        print("Segments已写入 audio_reserve\segments.txt 文件。")
    else:
        print("segments键不存在于result字典中。")
if __name__=="__main__":
    time_1=time.time()
    transformerVideoToAudio()
    time_2=time.time()
    print(f"总耗时：{time_2-time_1}秒")