from transformers import AutoTokenizer,AutoModel
#from bigdl.llm.transformers import AutoModel
import time
import torch
def GetExtract(model_path=r"D:\Code\chatglm2-6b",
            text_path=r"GetAudio\audio_reserve\text.txt",
            extract_path=r"GetExtract_local\Extract.txt",
            n_predict=8000):
    print("模型导入中......")
    

    tokenizer = AutoTokenizer.from_pretrained(model_path,trust_remote_code=True)
    model = AutoModel.from_pretrained(model_path,trust_remote_code=True).half().cuda()
    #model.eval()
    CHATGLM_V2_PROMPT_TEMPLATE = "总结下面的文字的大纲并，用数字编号来表示层级结构，例如1.1是1的子结构，请尽量给出详细的结构，不要带有任何无关的回复\n{prompt}\n答："
    with open (text_path,"r",encoding="utf-8") as f:
        prompt=f.read()
    with torch.inference_mode():
        prompt = CHATGLM_V2_PROMPT_TEMPLATE.format(prompt=prompt)
        input_ids = tokenizer.encode(prompt, return_tensors="pt")
        input_ids = input_ids.to('cuda')
        st = time.time()
        output = model.generate(input_ids,max_new_tokens=n_predict)
        end = time.time()
        output_str = tokenizer.decode(output[0], skip_special_tokens=True)
        parts=output_str.split("答：")
        if(len(parts)>1):
            output_str=parts[1]
        print(f'模型生成知识点摘要用时: {end-st} s')
        with open(extract_path,"w",encoding="utf-8") as f:
            f.write(output_str)
    
#GetExtract()